import 'package:decorated_flutter/decorated_flutter.dart';
import 'package:flutter/material.dart';
import 'package:nim_fluttify/nim_fluttify.dart';

class ExitChatroomScreen extends StatefulWidget {
  @override
  _ExitChatroomScreenState createState() => _ExitChatroomScreenState();
}

class _ExitChatroomScreenState extends State<ExitChatroomScreen> {
  ChatRoomInfoVM _vm;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('离开聊天室')),
      body: Center(
        child: DecoratedColumn(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text('聊天室id: 174163847'),
            RaisedButton(
              onPressed: _handleFetchChatRoomInfo,
              child: Text('获取聊天室信息'),
            ),
            RaisedButton(
              onPressed: _handleExit,
              child: Text('离开聊天室'),
            ),
            if (_vm != null) _ChatRoom(_vm),
          ],
        ),
      ),
    );
  }

  void _handleExit() async {
    Nim.instance
        .exitChatRoom('174163847')
        .loading(context, cancelable: true)
        .catchError(handle(context));
  }

  void _handleFetchChatRoomInfo() async {
    final roomInfo = await Nim.instance
        .fetchChatRoomInfo('174163847')
        .loading(context)
        .catchError(handle(context));
    _vm = await ChatRoomInfoVM.data(roomInfo);
    setState(() {});
  }
}

class ChatRoomInfoVM {
  static Future<ChatRoomInfoVM> data(ChatRoomInfo data) async {
    return ChatRoomInfoVM()
      ..roomId = await data.roomId
      ..announcement = await data.announcement
      ..broadcastUrl = await data.broadcastUrl
      ..creator = await data.creator
      ..onlineUserCount = await data.onlineUserCount
      ..name = await data.name;
  }

  String roomId;
  String name;
  String announcement;
  String broadcastUrl;
  String creator;
  int onlineUserCount;
}

class _ChatRoom extends StatelessWidget {
  const _ChatRoom(this.vm, {Key key}) : super(key: key);

  final ChatRoomInfoVM vm;

  @override
  Widget build(BuildContext context) {
    return DecoratedColumn(
      children: <Widget>[
        Text('聊天室id: ${vm.roomId}'),
        Text('聊天室名称: ${vm.name}'),
        Text('聊天室公告: ${vm.announcement}'),
        Text('聊天室创建人: ${vm.creator}'),
        Text('聊天室人数: ${vm.onlineUserCount}'),
      ],
    );
  }
}
