import 'package:decorated_flutter/decorated_flutter.dart';
import 'package:flutter/material.dart';
import 'package:nim_fluttify/nim_fluttify.dart';

import '../mixins.dart';

class LoginScreen extends StatefulWidget {
  @override
  _LoginScreenState createState() => _LoginScreenState();
}

class _LoginScreenState extends State<LoginScreen> with AccountTokenMixin {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text('登录')),
      body: Center(
        child: DecoratedColumn(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text('登录账户: $testAccount'),
            Text('登录token: $testToken'),
            RaisedButton(
              onPressed: _handleLogin,
              child: Text('登录'),
            ),
            if (result != null) Text(result),
          ],
        ),
      ),
    );
  }

  void _handleLogin() async {
    Nim.instance
        .login(account: testAccount, token: testToken)
        .loading(context)
        .then((value) => success())
        .catchError((error) => fail());
  }
}
