// ignore_for_file: camel_case_types
part of 'nim.dart';

class _AndroidCallback<T> extends java_lang_Object
    with
        java_io_Serializable,
        com_netease_nimlib_sdk_RequestCallback<T>,
        com_netease_nimlib_sdk_Observer<T> {
  _AndroidCallback({
    this.onSuccessListener,
    this.onFailedListener,
    this.onEventListener,
  });

  final ValueChanged<T> onSuccessListener;
  final ValueChanged<int> onFailedListener;
  final ValueChanged<T> onEventListener;

  //region com_netease_nimlib_sdk_RequestCallback
  @override
  Future<void> onSuccess(T var1) async {
    super.onSuccess(var1);
    if (onSuccessListener != null) onSuccessListener(var1);
  }

  @override
  Future<void> onFailed(int var1) async {
    super.onFailed(var1);
    if (onFailedListener != null) onFailedListener(var1);
  }

  //endregion

  //region com_netease_nimlib_sdk_Observer
  @override
  Future<void> onEvent(T var1) async {
    super.onEvent(var1);
    if (onEventListener != null) onEventListener(var1);
  }
//endregion
}

class _iOSCallback extends NSObject
    with
        NIMLoginManagerDelegate,
        NIMChatManagerDelegate,
        NIMChatroomManagerDelegate {
  _iOSCallback({
    this.onLoginStep,
    this.onMessageList,
    this.onChatRoomStatus,
    this.onKickOut,
  });

  final ValueChanged<NIMLoginStep> onLoginStep;
  final ValueChanged<List<NIMMessage>> onMessageList;
  final ValueChanged<ChatRoomStatus> onChatRoomStatus;
  final ValueChanged<KickOut> onKickOut;

  //region NIMLoginManagerDelegate
  @override
  Future<void> onLogin(NIMLoginStep step) async {
    super.onLogin(step);
    if (onLoginStep != null) onLoginStep(step);
  }
  //endregion

  //region NIMChatManagerDelegate
  @override
  Future<void> onRecvMessages(List<NIMMessage> messages) async {
    super.onRecvMessages(messages);
    if (onMessageList != null) onMessageList(messages);
  }
//endregion

  //region NIMChatroomManagerDelegate
  @override
  Future<void> chatroom_connectionStateChanged(
    String roomId,
    NIMChatroomConnectionState state,
  ) async {
    super.chatroom_connectionStateChanged(roomId, state);
    if (onChatRoomStatus != null) {
      onChatRoomStatus(ChatRoomStatus(roomId, state.toStatusType()));
    }
  }

  @override
  Future<void> chatroomBeKicked(NIMChatroomBeKickedResult result) async {
    super.chatroomBeKicked(result);
    if (onKickOut != null) {
      final roomId = await result.get_roomId();
      final reason = await result.get_reason();
      onKickOut(KickOut(roomId, reason.toKickOutReason()));
    }
  }

//endregion

}
